//+------------------------------------------------------------------+
//|                                                          HLV.mq4 |
//|                                                           brax64 |
//+------------------------------------------------------------------+
//
// Original idea by Egor at codebase.mql4.com
//
#property copyright "brax64"
#property link      "http://www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1 C'12,52,71'
#property indicator_color2 C'63,1,12'
#property indicator_color3 WhiteSmoke
#property indicator_color4 Crimson
#property indicator_color5 DodgerBlue
#property indicator_color6 DarkOrange
#property indicator_width1 15
#property indicator_width2 15
#property indicator_width3 2
#property indicator_width4 3
#property indicator_width5 3
#property indicator_width6 0
#property indicator_level1 0
#property indicator_levelcolor C'40,40,40'
#property indicator_levelstyle 2

extern string TimeFrame      = "Current time frame";
extern int    HL_Period      = 16;
extern double Str_Level      = 0.001;
extern bool   Show_Line      = false;
extern bool   Show_Bands     = true;
extern string note1          = "Smooth_Period <= 1 for no smoothing";
extern int    Smooth_Period  = 4;
extern string note2          = "0:SMA 1:EMA 2:SMMA 3:LWMA";
extern int    Smooth_MA_Mode = 2;
extern bool   Interpolate    = true;

double modifier;
double str[], HLup[], HLdn[], HIb[], LOb[], wrk0[], wrk1[], HLV[];


//
//
//
//
//

int    timeFrame;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorDigits(6);
   IndicatorBuffers(8);
   
      //
      //
      //
      //
      //
      
      modifier = 1; if(StringFind(Symbol(),"JPY",0) != -1) modifier = 100;
      SetIndexBuffer(0, HIb); 
      SetIndexBuffer(1, LOb);
      SetIndexBuffer(2, HLV);  SetIndexStyle(2, DRAW_NONE);      SetIndexLabel(2, "HLV ");
      SetIndexBuffer(3, HLdn); SetIndexStyle(3, DRAW_HISTOGRAM); SetIndexLabel(3, "HL- ");
      SetIndexBuffer(4, HLup); SetIndexStyle(4, DRAW_HISTOGRAM); SetIndexLabel(4, "HL+ ");
      SetIndexBuffer(5, str);  SetIndexStyle(5, DRAW_ARROW);     SetIndexLabel(5, "Strength "); SetIndexArrow(5,167);
      SetIndexBuffer(6, wrk0);
      SetIndexBuffer(7, wrk1);
      if(Show_Bands)
      {
         SetIndexStyle(0, DRAW_HISTOGRAM); SetIndexLabel(0, "H_Band ");
         SetIndexStyle(1, DRAW_HISTOGRAM); SetIndexLabel(1, "L_Band ");
      }   
      if(Show_Line)
      {
         SetIndexStyle(2, DRAW_LINE);
         SetIndexStyle(3, DRAW_LINE);
         SetIndexStyle(4, DRAW_LINE);
      }
      
      //
      //
      //
      //
      //
   
      indicatorFileName = WindowExpertName();
      calculateValue    = (TimeFrame=="CalculateStr"); if (calculateValue) return(0);
      returnBars        = (TimeFrame=="returnBars");   if (returnBars)     return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
         
   //
   //
   //
   //
   //
   
   string tf = timeFrameToString(timeFrame);

   if (Smooth_MA_Mode < 0 || Smooth_MA_Mode > 3) Smooth_MA_Mode = 0;
      string Sm_MA_Mode = "";
      switch(Smooth_MA_Mode)
      {
         case 0: Sm_MA_Mode = "SMA";  break;
         case 1: Sm_MA_Mode = "EMA";  break;
         case 2: Sm_MA_Mode = "SMMA"; break;
         case 3: Sm_MA_Mode = "LWMA"; break;
      }
   
      if(Show_Bands == false)              IndicatorShortName(tf+" HLV ("+HL_Period+")");
      if(Show_Bands && Smooth_Period <= 1) IndicatorShortName(tf+" HLV bands ("+HL_Period+")");
      if(Show_Bands && Smooth_Period >  1) IndicatorShortName(tf+" HLV " +Sm_MA_Mode +" smoothed bands (" +HL_Period +", " +Smooth_Period +")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
    int counted_bars = IndicatorCounted();
       if(counted_bars < 0) return(0);
       if(counted_bars > 0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);      
         if (returnBars) { HIb[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //
        
   if (calculateValue || timeFrame==Period())
   {      
      for(int k = 0; k < limit; k++)
      { 
         double a = 0;
         double b = 0;
         double c = 0;
         double d = 0;
         double e = 0;
         for(int i=k; i<k+HL_Period; i++) 
         {
            if(iHigh(NULL, 0, k) > iHigh(NULL, 0, i) && iHigh(NULL, 0, k) - iHigh(NULL, 0, i) > a) a = iHigh(NULL, 0, k) - iHigh(NULL, 0, i);
            if( iLow(NULL, 0, k) <  iLow(NULL, 0, i) &&  iLow(NULL, 0, k) -  iLow(NULL, 0, i) < b) b =  iLow(NULL, 0, k) -  iLow(NULL, 0, i);
               c = a + b;
               d = a - b;
               e = b - a;          
         }
      
         str[k]  = EMPTY_VALUE;
         HLdn[k] = EMPTY_VALUE;
         HLup[k] = EMPTY_VALUE;
         wrk0[k] = EMPTY_VALUE;
         if (Show_Line) HLV[k] = c;
            if (c == d || c == e && c > 0)  str[k] = -Str_Level * modifier;
            if (c == d || c == e && c < 0)  str[k] =  Str_Level * modifier;
            if (c  < 0)                    HLdn[k] =  c;
            if (c  > 0)                    HLup[k] =  c;
            if (c == 0)                  
            { 
               HLdn[k] =  EMPTY_VALUE;
               HLup[k] =  EMPTY_VALUE;
            }
            wrk0[k] =  d * 1.618;                                    
      }
      for(k = 0; k < limit; k++)
      {
         if(Show_Bands)      
         {          
            wrk1[k] = NormalizeDouble(iMAOnArray(wrk0, 0, Smooth_Period, 0, Smooth_MA_Mode, k), 4);
            if(Smooth_Period > 1)
            {
               HIb[k] = wrk1[k];
               LOb[k] = -HIb[k];
            }
            else
            {
               HIb[k] = wrk0[k];
               LOb[k] = -HIb[k];
            }
         }            
      }
      return(0);
   }
   
   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
      if (Show_Bands) HIb[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",HL_Period,Str_Level,Show_Line,Show_Bands,"",Smooth_Period,"",Smooth_MA_Mode,0,y);
      if (Show_Bands) LOb[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",HL_Period,Str_Level,Show_Line,Show_Bands,"",Smooth_Period,"",Smooth_MA_Mode,1,y);
                      HLV[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",HL_Period,Str_Level,Show_Line,Show_Bands,"",Smooth_Period,"",Smooth_MA_Mode,2,y);
                      HLdn[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",HL_Period,Str_Level,Show_Line,Show_Bands,"",Smooth_Period,"",Smooth_MA_Mode,3,y);
                      HLup[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",HL_Period,Str_Level,Show_Line,Show_Bands,"",Smooth_Period,"",Smooth_MA_Mode,4,y);
                      str[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",HL_Period,Str_Level,Show_Line,Show_Bands,"",Smooth_Period,"",Smooth_MA_Mode,5,y);
     
      //
      //
      //
      //
      //
       
      if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue; 
         if (Show_Bands) interpolate(HIb ,iTime(NULL,timeFrame,y),i);
         if (Show_Bands) interpolate(LOb ,iTime(NULL,timeFrame,y),i);
                         interpolate(HLV ,iTime(NULL,timeFrame,y),i);
         if (!Show_Line) interpolate(HLdn,iTime(NULL,timeFrame,y),i);
         if (!Show_Line) interpolate(HLup,iTime(NULL,timeFrame,y),i);
   }
   if (Show_Line)
      for (i=limit; i>=0; i--)
      {
         if (HLdn[i] != EMPTY_VALUE) HLdn[i]=HLV[i];
         if (HLup[i] != EMPTY_VALUE) HLup[i]=HLV[i];
      }
}




//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void interpolate(double& buffer[], datetime time, int i)
{
   for (int n = 1; (i+n) < Bars && Time[i+n] >= time; n++) continue;
   
   //
   //
   //
   //
   //
   
   if (buffer[i] == EMPTY_VALUE || buffer[i+n] == EMPTY_VALUE) n=-1;
               double increment = (buffer[i+n] - buffer[i])/ n;
   for (int k = 1; k < n; k++)     buffer[i+k] = buffer[i] + k*increment;
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}